const fs = require("fs");
const path = require("path");
const Jimp = require('jimp');
var sizeOf = require('image-size');
var readline = require('readline');
var os = require('os');

// console.time("test");


const pwd = __dirname;
const target_str = '.assets';

// crop( x, y, w, h)
async function crop(x, y, width, height, i, element, pic) {
    // 读取图片
    const image = await Jimp.read(pic);
    // await image.crop(0, 0, 1000, 150);
    await image.crop(x, y, width, height);
    // 保存
    // image-20220225173606089.png
    // image-20220225173606089
    await image.writeAsync(`${element.split(".")[0]}/${i}.png`);
    console.log('图片已经切完了一张。');
}

function puls_str(file_name, num) {
    var fReadName = file_name;
    var fWriteName = `${fReadName.split(".")[0]}[副本].md`;
    var fRead = fs.createReadStream(fReadName);
    var fWrite = fs.createWriteStream(fWriteName);


    var objReadline = readline.createInterface({
        input: fRead,
        // 这是另一种复制方式，这样on('line')里就不必再调用fWrite.write(line)，当只是纯粹复制文件时推荐使用
        // 但文件末尾会多算一次index计数
        //  output: fWrite, 
        //  terminal: true
    });


    var index = 1;
    objReadline.on('line', (line) => {
        // var tmp = 'line' + index.toString() + ':' + line;
        if (line.indexOf("!") === 0) {

            // console.log(index, line);
            // ![image-20220225173606089](connecting.assets/image-20220225173606089.png)
            // line = '![image-20220225173606089](connecting.assets/image-20220225173606089.png)'
            // ![](image-20220225173606089/(0).jpg)
            pic_dir_name = line.slice(line.indexOf('[') + 1, line.indexOf(']'));
            num = fs.readdirSync(pic_dir_name).length;
            for (let x = 1; x <= num; x++) {
                // const element = array[x];
                // md_str = f"![]({pic.split('.')[0]}/({x - 1}).jpg)"
                md_str = `![](${pic_dir_name}/${x - 1}.png)`;

                fWrite.write("\n");
                fWrite.write(`${md_str}\n`);
            }

        } else {
            fWrite.write(line);
            fWrite.write(os.EOL); // 下一行
        }
        index++;
    });

    objReadline.on('close', () => {
        console.log('readline close...');
    });
}

fs.readdir(pwd, function (err, files) {
    if (err) {
        return console.log(err);
    } else {
        files.forEach(function (item) {
            // console.log(item);
            if (item.indexOf(target_str) != -1) {
                dir_name = item;
                // dir_name就是工作目录下的'.assets'图片文件夹
                fs.readdir(path.join(pwd, dir_name), function (err, files) {
                    if (err) {
                        return console.log(err);
                    } else {
                        // console.log(files);
                        file_name = dir_name.split(target_str)[0] + ".md";
                        for (let i = 0; i < files.length; i++) {
                            const element = files[i];
                            // console.log(element);
                            // console.log(element.split(".")[0]);
                            if (fs.readdirSync(pwd).includes(element.split(".")[0]) == false) {
                                // console.log(element.split(".")[0]);
                                let dir_path = element.split(".")[0]
                                // fs.mkdir(path.join(pwd, dir_path), function (err) {
                                //     if (err) {
                                //         return console.log(err);
                                //     } else {
                                //         console.log(`${dir_path}文件夹创建完成`);
                                //     }
                                // })
                                fs.mkdirSync(path.join(pwd, dir_path));
                                console.log(`${dir_path}文件夹创建完成`);
                            }
                            // 传入图片的相对路径。
                            // path.join(dir_name, element);
                            console.log(path.join(dir_name, element));
                            // 传入图片的相对路径。
                            var pic = path.join(dir_name, element);
                            var dimensions = sizeOf(pic);
                            img_y = dimensions.width > 1200 ? dimensions.width / 35 : 1200 / 35;

                            for (let i = 0; dimensions.height - img_y * i > 0; i++) {
                                if (dimensions.height - img_y * i > img_y) {
                                    crop(0, img_y * i, dimensions.width, img_y, i, element, pic);
                                } else {
                                    crop(0, img_y * i, dimensions.width, dimensions.height - img_y * i, i, element, pic);
                                }

                            }
                            // console.log("图片切完了一张。");
                            // console.log("图片全都切完了。");
                            //puls_str(file_name);
                        }
                        // console.log("任务已经完成了。");
                        // console.timeEnd("test");
                    }
                });
            }
        });
    }
});